<?php
/*
* 2007-2012 eTiendas
* 
*
* NOTICE OF LICENSE
*
* Copy Right, all rights reserved: eTiendas SAS
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize this module for your
* needs please contact http://www.etiendas.co.
*
*  @author eTiendas SAS <contact@etiendas.co>
*  @copyright  2007-2012 eTienas SAS
*  @version  Release: $Revision: 3.2 $
*  @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
*  International Registered Trademark & Property of eTiendas SAS
*/
	if (!defined('_PS_VERSION_'))
		exit;

class registereMailOnly extends Module
{	
	const __REGONLY_MAIL_DELIMITOR__ = ',';
	private $_merchant_mails;
	private $_html = '';
	public function __construct()
	{
		$this->name = 'registeremailonly';
		$this->tab = 'front_office_features';				
		$this->version = '1.3';
		$this->author = 'eTiendas.co';
		
		parent::__construct();
		
		$this->displayName = $this->l('www.eTiendas.co Free Module: Customer Registration Admin Alerts');
		$this->description = $this->l('Email Admin of customer registration');
		$this->_refreshProperties();
	}  

	public function install()
	{
		if (!parent::install() OR !$this->registerHook('createAccount'))
			return false;	
			
		$this->_moveModulePosition(1,'createAccount');
		Configuration::updateValue('REGEMAIL_ADMIN_MAILS', Configuration::get('PS_SHOP_EMAIL'));
		return TRUE;
	}
    public function uninstall()
	{
		if (!parent::uninstall())
			return false;
		Configuration::deleteByName('REGEMAIL_ADMIN_MAILS');
		return TRUE;
	}
	
	public function disable($forceAll = false)
	{
		if (!parent::disable())
			return false;
		return;
	}
	
	public function enable($forceAll = false)
	{
		if (!parent::enable())
			return false;
		$this->_moveModulePosition(1,'createAccount');
		return;
	}

 	function hookCreateAccount($params)
	{
		$custInfo = $params['_POST'];		
		if (empty($custInfo))
			return false;		
		if (version_compare(_PS_VERSION_, '1.5', '>=')) 
		{
			$country_name  = Country::getNameById($this->context->language->id, Configuration::get('PS_COUNTRY_DEFAULT'));
		}else{
			global $cookie;
			$country_name  = Country::getNameById(intval($cookie->id_lang), intval($custInfo['id_country']));
		}
			$emailVars = array('{firstname}' => $custInfo['firstname']
							,'{lastname}' => $custInfo['lastname']
							,'{email}' => $custInfo['email']
							,'{shop_name}' => Configuration::get('PS_SHOP_NAME')
							,'{address1}' => $custInfo['address1']
							,'{address2}' => $custInfo['address2']
							,'{postcode}' => $custInfo['postcode']
							,'{city}' => $custInfo['city']
							,'{country}' => $country_name
							,'{state}' => State::getNameById(intval($custInfo['id_state']))	
							,'{phone}' => $custInfo['phone']
							,'{phone_mobile}' => $custInfo['phone_mobile']
							,'{company}' => $custInfo['company']
							,'{birthday}' => $custInfo['months'].'-'.$custInfo['days'].'-'.$custInfo['years']
							,'{other}' => $custInfo['other']
						);
						
			$template = 'registeremailonly';
//			$template = 'registeredclientsonly';
			Mail::Send((int)(Configuration::get('PS_LANG_DEFAULT')),$template,Mail::l('New Customer Account Registration'),$emailVars,explode(self::__REGONLY_MAIL_DELIMITOR__,$this->_merchant_mails),NULL,strval(Configuration::get('PS_SHOP_EMAIL')),strval(Configuration::get('PS_SHOP_NAME')),NULL,NULL, dirname(__FILE__).'/mails/');
			return;
	}

	public function _displayForm()
	{
		$this->_html .= '
		<form action="'.Tools::safeOutput($_SERVER['REQUEST_URI']).'" method="post">
			<fieldset class="width3"><legend>'.$this->l('Additional New Account Registration Email Notifications to:').'</legend>
				<label>'.$this->l('Notify:').' </label>
				<div class="margin-form">
					<div style="float:left; margin-right:10px;">
						<textarea name="REGEMAIL_ADMIN_MAILS" rows="5" cols="30">'.Tools::getValue('REGEMAIL_ADMIN_MAILS', str_replace(self::__REGONLY_MAIL_DELIMITOR__, "\n", $this->_merchant_mails)).'</textarea>
					</div>
					<div style="float:left;">
						'.$this->l('One e-mail address per line').'<br />
					</div>
				</div>
				<div style="clear:both;">&nbsp;</div>
				<div class="margin-form">
					<input type="submit" value="'.$this->l('   Save   ').'" name="submitROMerchant" class="button" />
				</div>
			</fieldset>
		</form>
    	<ul>
            <li><a target="_blank" href="http://www.etiendas.co">'.$this->l('More Modules by eTiendas').'.</a></li>
        </ul>
        <br />
        Free Work from: <a href="http://etiendas.co">eTiendas</a>
';
	}

private function _moveModulePosition($position,$hookname) 
	{
		if (_PS_VERSION_ < '1.5') {
			  $hookID = (int)Hook::get($hookname);
		} else {
			  $hookID = (int)Hook::getIdByName($hookname);
		}
		$moduleInstance = Module::getInstanceByName($this->name);
		if (_PS_VERSION_ < '1.5') {
			  $moduleInfo = Hook::getModuleFromHook($hookID, $moduleInstance->id);
		} else {
			  $moduleInfo = Hook::getModulesFromHook($hookID, $moduleInstance->id);
		}
		if (_PS_VERSION_ < '1.5') {
			 if ((int)$moduleInfo['position'] > (int)$position) {
			   return $moduleInstance->updatePosition($hookID, 0, (int)$position);
		} else {
		return $moduleInstance->updatePosition($hookID, 1, (int)$position);
		}
		} else {
		if ((int)$moduleInfo['m.position'] > (int)$position) {
			   return $moduleInstance->updatePosition($hookID, 1, (int)$position);
		} else {
		return $moduleInstance->updatePosition($hookID, 0, (int)$position);
		}
		}
	}
	private function _refreshProperties()
	{
		$this->_merchant_mails = Configuration::get('REGEMAIL_ADMIN_MAILS');
	}
	public function getContent()
	{
		$this->_html = '<h2>'.$this->displayName.'</h2>';
		$this->_postProcess();
		$this->_displayForm();
		return $this->_html;
	}

	public function _postProcess()
	{
		$this->_html = '<h2>'.$this->displayName.'</h2>';
		if (Tools::isSubmit('submitROMerchant'))
		{
			$emails = strval(Tools::getValue('REGEMAIL_ADMIN_MAILS'));
			if (!$emails || empty($emails))
				$this->_html .= '<div class="alert error">'.$this->l('Please type one (or more) e-mail address').'</div>';
			else
			{				
				$emails = explode("\n", $emails);
				foreach ($emails as $k => $email)
				{
					$email = trim($email);
					if (!empty($email) && !Validate::isEmail($email))
						return ($this->_html .= '<div class="alert error">'.$this->l('Invalid e-mail:').' '.$email.'</div>');
					if (!empty($email) && count($email))
						$emails[$k] = $email;
					else
						unset($emails[$k]);
				}
				$emails = implode(self::__REGONLY_MAIL_DELIMITOR__, $emails);
				if (!Configuration::updateValue('REGEMAIL_ADMIN_MAILS', strval($emails)))
					$this->_html .= '<div class="alert error">'.$this->l('Cannot update settings').'</div>';
				else
					$this->_html .= '<div class="conf confirm"><img src="../img/admin/ok.gif" alt="'.$this->l('Confirmation').'" />'.$this->l('Settings updated').'</div>';
			}
		}		
		$this->_refreshProperties();
	}
}